
rout			;when this is off, the routine-file will be
			;assembled, on=testing
			
;debug			;when this is on, colors in the background will
			;show how much time the routine needs.


routinemode	equ	0	;the routinemode !


; the first part of the source handles the things that are necessary to
; show the picture/copper and playing of the routine.
; the part between the "***" lines is the routine-source.
; at the bottom of the file, there are the necessary incbin-files who
; are needed to test the routine.
; these are saved with "save effect" in videotracker. they are raw
; data files which can be fonts,pictures,landscapes,vectorobjects
; etcetra.
; the incbin-files are put in the "variables" table, in the routine-
; player-handler
; the place where it's done can be found by searching for "!!!"


	opt	a+	;devpac 3 optimize
	opt	o+

	ifd	rout
	;videotracker routine-test

	incdir	"videotracker:include/"
	include	"exec/types.i"
	include	"graphics/gfxbase.i"
	include	"lvo/graphics_lib.i"
	incdir	'videotracker:effect/'

vew_wid	equ	44
vew_hgt	equ	290
win_hgt	equ	117
win_str	equ	$1a

	SECTION	1,CODE_C
tus
	move.l	($4).w,a6
	sub.l	a1,a1
	jsr	-$126(a6)		;findtask
	move.l	d0,curtsk
	move.l	d0,a0
	move.l	$b8(a0),tskpri

	lea	dosnam,a1		;doslib openen
	moveq.l	#0,d0
	move.l	(4).w,a6
	jsr	-408(a6)		;openlib
	move.l	d0,doslib

	bsr.s	label5			;videotracker opstarten
	
	move.l	curtsk,a0
	move.l	tskpri,$b8(a0)
	move.l	($4).w,a6
	jsr	-$84(a6)		;forbid

	move.l	doslib,a1
	move.l	(4).w,a6
	jsr	-414(a6)		;closelib

	moveq.l	#0,d0
	rts
	
label5
	move.l	(4).w,a6		;workbench gedoe
	move.b	530(a6),ntscmode	;50/60 hertz halen

	cmp.b	#50,ntscmode		;ntsc ?
	beq.s	str.ntsc
	move.l	#vew_hgt-56,hogscr	;set NTSC screen hight
str.ntsc

;	move.l	(4).w,a6		;68030 cache off 
;	jsr	-120(a6)
;
;	btst.b	#1,297(a6)
;	beq.s	str.nfc
;	lea.l	str.ft,a5
;	jsr	-30(a6)
;str.nfc
;	jsr	-126(a6)
;	bra.s	str.fc
;	
;str.ft
;	dc.w	$4e7a,2
;	bclr	#0,d0
;	bset	#13,d0
;	dc.w	$4e7b,2
;	rte
;str.fc

	lea	cprjmp,a2		;copjmp zetten !
	move.l	#cprbck-8,d0
	move.w	d0,6(a2)
	swap	d0
	move.w	d0,2(a2)

	lea	cprbck-8,a2		;copstr zetten !
	move.l	#cpr,d0
	move.w	d0,6(a2)
	swap	d0
	move.w	d0,2(a2)

	bsr	cprsprrem		;sprites legen

	lea	gfxnam,a1		;graphics lib openen
	move.l	(4).w,a6
	jsr	-408(a6)		;openlib
	move.l	d0,a6
	move.l	d0,gfxlib
	move.l	38(a6),oldcprlist

	bset	#1,$bfe001
	bsr	copbuf			;copper vullen

	bsr	sysoff

gadrun
	btst	#6,($bfe001).l
	bne	gadrun

scrend
scrend.play
	bsr	syson

	move.l	gfxlib,a1
	move.l	(4).w,a6
	jsr	-414(a6)		;closelib

scrend.qb
	moveq.l	#0,d0	
	rts
	
	;vertical blank interrupt, no blits.
	;handles counters,interlace,sprite
	;level 3

intvb
	bra.s	intvb.cnt
	dc.l	'VIDU'
	dc.l	'LOOP'
intvb.cnt
	movem.l	d0-d7/a0-a6,-(sp)
	lea	($dff000).l,a6

	move.w	$01e(a6),d0
	btst	#5,d0			;vblank ?
	bne.s	intvb.vb

	bra.s	intcop.end

intvb.vb
	bsr	grap
	bsr	palctr			;palette zetten
	bsr.s	copbuf			;copper vullen
	
intvb.end
	move.w	#$0020,$09c(a6)	;vb bit wissen
	movem.l	(sp)+,d0-d7/a0-a6	;multitask uit, shit !
	rte

intcop.end
	movem.l	(sp)+,d0-d7/a0-a6
	move.l	intvbold,-(sp)
	rts

	;transmission buffer empty routine, BLIT !
	;handles routines,animations
	
inttbe					;tbe interrupt
	movem.l	d0-d7/a0-a6,-(sp)
	lea	($dff000).l,a6

	move.w	$01e(a6),d0
	btst	#0,d0			;no tbe ?
	beq.s	intdskblk


	btst	#6,($bfe001).l		;muis ingedrukt ?
	beq.s	inttbe.cop
	btst	#2,($dff016).l
	beq.s	inttbe.cop

	ifd	debug
	move.w	#$700,$dff180
	endc
	
	bsr	rotply			;routineplayer BLIT !
	bsr.s	copbuf			;copper vullen

	ifd	debug
	move.w	#$070,$dff180
	endc
	
inttbe.cop

inttbe.end
	move.w	#$0001,$09c(a6)
	movem.l	(sp)+,d0-d7/a0-a6
	rte

intdskblk
	move.w	#$0001,$09c(a6)		;be sure for no tbe handling
	movem.l	(sp)+,d0-d7/a0-a6
	move.l	inttbeold,-(sp)
	rts


	;moves the copperbuffer to the copperlist
	;sort of double buffering
	
copbuf
	movem.l	d0-d7/a0-a6,-(sp)

	lea	($dff000).l,a6

copbuf.novb				;copperchange overslaan
	moveq.l	#0,d0
	move.b	$005(a6),d0
	lsl.w	#8,d0
	moveq.l	#0,d1
	move.b	$006(a6),d1
	add.w	d1,d0

	cmp.w	#$4,d0
	blt	copbuf.novb

	cmp.b	#50,ntscmode
	beq.s	copbuf.pal
	cmp.w	#$133-56-8,d0		;ntsc grens
	bge	copbuf.novb
	bra.s	copbuf.cont
copbuf.pal
	cmp.w	#$133-8,d0		;pal grens
	bge	copbuf.novb
copbuf.cont

	lea	gra.s,a0		;buffer copieren
	lea	cprbuf,a1

	move.w	00*4+2(a0),00*4+2(a1)
	move.w	01*4+2(a0),01*4+2(a1)
	move.w	02*4+2(a0),02*4+2(a1)
	move.w	03*4+2(a0),03*4+2(a1)
	move.w	04*4+2(a0),04*4+2(a1)
	move.w	05*4+2(a0),05*4+2(a1)
	move.w	06*4+2(a0),06*4+2(a1)
	move.w	07*4+2(a0),07*4+2(a1)
	move.w	08*4+2(a0),08*4+2(a1)
	move.w	09*4+2(a0),09*4+2(a1)

	move.w	10*4+2(a0),10*4+2(a1)
	move.w	11*4+2(a0),11*4+2(a1)
	move.w	12*4+2(a0),12*4+2(a1)
	move.w	13*4+2(a0),13*4+2(a1)
	move.w	14*4+2(a0),14*4+2(a1)
	move.w	15*4+2(a0),15*4+2(a1)
	move.w	16*4+2(a0),16*4+2(a1)
	move.w	17*4+2(a0),17*4+2(a1)
	move.w	18*4+2(a0),18*4+2(a1)
	move.w	19*4+2(a0),19*4+2(a1)

	move.w	20*4+2(a0),20*4+2(a1)
	move.w	21*4+2(a0),21*4+2(a1)
	move.w	22*4+2(a0),22*4+2(a1)
	move.w	23*4+2(a0),23*4+2(a1)
	move.w	24*4+2(a0),24*4+2(a1)
	move.w	25*4+2(a0),25*4+2(a1)
	move.w	26*4+2(a0),26*4+2(a1)
	move.w	27*4+2(a0),27*4+2(a1)
	move.w	28*4+2(a0),28*4+2(a1)
	move.w	29*4+2(a0),29*4+2(a1)

	move.w	30*4+2(a0),30*4+2(a1)
	move.w	31*4+2(a0),31*4+2(a1)
	move.w	32*4+2(a0),32*4+2(a1)
	move.w	33*4+2(a0),33*4+2(a1)
	move.w	34*4+2(a0),34*4+2(a1)
	move.w	35*4+2(a0),35*4+2(a1)
	move.w	36*4+2(a0),36*4+2(a1)
	move.w	37*4+2(a0),37*4+2(a1)
	move.w	38*4+2(a0),38*4+2(a1)
	move.w	39*4+2(a0),39*4+2(a1)

	move.w	40*4+2(a0),40*4+2(a1)
	move.w	41*4+2(a0),41*4+2(a1)
	move.w	42*4+2(a0),42*4+2(a1)
	move.w	43*4+2(a0),43*4+2(a1)
	move.w	44*4+2(a0),44*4+2(a1)
	move.w	45*4+2(a0),45*4+2(a1)
	move.w	46*4+2(a0),46*4+2(a1)
	move.w	47*4+2(a0),47*4+2(a1)
	move.w	48*4+2(a0),48*4+2(a1)
	move.w	49*4+2(a0),49*4+2(a1)

	move.w	50*4+2(a0),50*4+2(a1)
	move.w	51*4+2(a0),51*4+2(a1)
	move.w	52*4+2(a0),52*4+2(a1)
	move.w	53*4+2(a0),53*4+2(a1)
	move.w	54*4+2(a0),54*4+2(a1)

copbuf.end
	movem.l	(sp)+,d0-d7/a0-a6
	rts

	;goes back to the workbench
	
syson
	movem.l	d0-d7/a0-a6,-(sp)

	move.w	#$0001,$dff09a		;tbeint uit
	move.l	intvbold,($6c).w
	move.l	inttbeold,($64).w

	move.l	4,a6
	jsr	-138(a6)		;permit

	move.l	gfxlib,a6
	jsr	-462(a6)		;disownblitter

	move.l	wbview,a1
	move.l	gfxlib,a6
	jsr	_LVOLoadView(a6) 	; Fix view
	jsr	_LVOWaitTOF(a6)
	jsr	_LVOWaitTOF(a6)         ; wait for LoadView()

syson.ras
	cmp.b	#$c0,$dff006		;prevent copperjump
	bne	syson.ras

	move.l	gfxlib,a6
	move.l	gb_copinit(a6),$dff080	 ; Kick it into life

	movem.l	(sp)+,d0-d7/a0-a6
	rts
	
	;goes back to the gadgetscreen
	
sysoff
	movem.l	d0-d7/a0-a6,-(sp)
 	
	move.l	gfxlib,a6
	move.l	gb_ActiView(a6),wbview	;current view
	sub.l	a1,a1			; clear a1
	jsr 	_LVOLoadView(a6) 	; Flush View to nothing
	jsr	_LVOWaitTOF(a6) 	; Wait once
	jsr	_LVOWaitTOF(a6) 	; Wait again.

	move.l	gfxlib,a6
	jsr	-456(a6)		;ownblitter

	move.l	4,a6
	jsr	-132(a6)		;forbid
		
	move.l	($6c).w,intvbold
	move.l	#intvb,($6c).w
	move.l	($64).w,inttbeold
	move.l	#inttbe,($64).w
	move.w	#$8001,$dff09a		;tbeint aan
	bsr	gracpr			;reset copper
	bsr	copbuf			;copy copper
	move.l	#cpr,$dff080

	movem.l	(sp)+,d0-d7/a0-a6
	rts
	
cprsprrem
	movem.l	d0-d7/a0-a6,-(sp)
	lea	cprspr,a0
	move.l	#sprdat,d0
	move.w	#7,d1
cprsprrem.a
	move.w	d0,3*2(a0)
	swap	d0
	move.w	d0,1*2(a0)
	swap	d0
	add.l	#8,a0
	dbra	d1,cprsprrem.a
	movem.l	(sp)+,d0-d7/a0-a6
	rts

varset					;variablen neerzetten
	movem.l	d0-d7/a0-a6,-(sp)
	move.l	#var,a0

	move.l	#cprbck,var_cprbck(a0)
	move.l	gfxlib,var__GfxBase(a0)
	move.b	ntscmode,var_ntsc(a0)

	move.l	curpic1,var_pic1(a0)	;variabel
	move.l	curpic2,var_pic2(a0)	;variabel
	move.w	anispd1,var_anispd1(a0)
	move.w	anitel1,var_anitel1(a0)
	movem.l	(sp)+,d0-d7/a0-a6
	rts
	
	;this routine handles all videotracker-routines

rotply	
	movem.l	d0-d7/a0-a6,-(sp)

	moveq.l	#0,d0

	lea	currot1,a2		;routine 1
	move.w	rotinf1,d0		;routine info
	bsr.s	rotplyr

rotply.end
	movem.l	(sp)+,d0-d7/a0-a6
	rts

	;this routine handles 1 routine, BLIT !
	
rotplyr
	movem.l	d0-d7/a1-a6,-(sp)

	move.l	#rot,(a2)		;routinestart address

	move.b	#50,ntscmode		;ntsc/pal hz
	clr.l	curpic2			;background picture
	move.w	#1,anispd1		;animationspeed
	clr.w	anitel1			;animation position

	lea	var,a0			;communication-table

	move.l	#rotsrc,var_bck(a0)	;background picture !!!
	move.l	#routinemode,d0		;routinemode !!!

	sub.l	a0,a0			;picture info legen

	tst.l	(a2)			;is er een routine ?
	beq	rotplyr.end		;interlace handling

	move.l	intdel,d2		;delay
	move.l	inttel,d1		;teller
	cmp.w	d2,d1
	blt	rotplyr.end
	clr.l	inttel
				
	bsr	varset			;variabelen updaten

	move.l	(a2),a1			;routine halen
	move.l	#var,a0			;variablen tabel

	movem.l	d3-d7/a1-a6,-(sp)
	moveq.l	#0,d1			;vars wissen
	moveq.l	#0,d2
	moveq.l	#0,d3
	moveq.l	#0,d4
	moveq.l	#0,d5
	moveq.l	#0,d6
	moveq.l	#0,d7
	sub.l	a2,a2
	sub.l	a3,a3
	sub.l	a4,a4
	sub.l	a5,a5

	jsr	4(a1)			;routine afwerken
	movem.l	(sp)+,d3-d7/a1-a6

	;Routine:
	;
	;Input:
	;a0=variabelentabel
	;d0=routinemode
	;
	;Output:
	;a0=picture
	;d1=copperlist
	;d2=interruptdelay		(NOT used till now)
	
	move.w	#$0020,$dff09a		;vb off !

	move.l	d2,intdel		;delay

	lea	cprjmp,a3
	move.l	#cprbck-8,d0

	cmp.l	(a2),a1			;routine ondertussen gewipt ?
	bne.s	rotplyr.nocop
	tst.l	d1			;copperlist ?
	beq.s	rotplyr.nocop
	move.l	d1,d0
rotplyr.nocop
	move.w	d0,6(a3)
	swap	d0
	move.w	d0,2(a3)

	cmp.l	#0,a0			;picture ?
	beq.s	rotplyr.endvb

	move.l	a0,curpic1		;current picture (cycle)
	move.l	a0,curpal1		;current palette

	tst.b	rotdpl			;plane is geleverd
	beq.s	rotplyr.set
	clr.b	rotdpl
	clr.l	cycdel1			;cycle info wissen
	clr.l	4+cycdel1
	clr.l	curfrm1			;curfrm1, altijd planes zetten
rotplyr.set
	clr.b	dplctr
	bsr.s	grap
	bsr	grac			;colorset
rotplyr.endvb
	move.w	#$8020,$dff09a
rotplyr.end
	movem.l	(sp)+,d0-d7/a1-a6
	rts

	;removes possible routine-coppers
	
gracpr
	movem.l	d0-d7/a0-a6,-(sp)
	lea	cprjmp,a3
	move.l	#cprbck-8,d0		;copperlist resetten
	move.w	d0,6(a3)
	swap	d0
	move.w	d0,2(a3)
	movem.l	(sp)+,d0-d7/a0-a6
	rts

	;picture-to-copper routine, communicates with the
	;anim-player
	
grap					;d7=anim
	movem.l	d0-d7/a0-a6,-(sp)

	clr.l	d7
	
	tst.l	curpic1			;current picture ?
	beq	grap.end

	move.l	curpic1,a2		;normal pic halen

	lea	gracprscr,a1		;window neerzetten
	move.l	hogscr,d1

	move.w	pic_hgt(a2),d3		;pic hoogte
	move.w	pic_vew(a2),d5
	btst	#2,d5			;interlace ?
	beq.s	grap.nohi4
	lsr.w	#1,d3			;/2
grap.nohi4
	cmp.w	d3,d1
	bge.s	grap.hog
	move.w	d1,d3
grap.hog
	sub.w	d3,d1
	lsr.w	#1,d1
	add.w	#win_str,d1
	move.w	d1,d2
	add.w	d3,d2


	move.b	d1,2(a1)		;y start
	move.b	d2,6(a1)		;y end

	move.w	pic_wid(a2),d4		;pic breedte in bytes
	lsl.l	#3,d4			;make pixels

	move.l	#vew_wid*8,d0
	move.l	#0,d1
	move.l	#$71,d6

	move.w	pic_vew(a2),d5
	btst	#15,d5			;hires ?
	beq.s	grap.nohi2

	move.l	#(vew_wid-4)*8*2,d0
	move.l	#1,d1
	move.l	#$81,d6

	cmp.w	#80,pic_wid(a2)		;overscan ?
	ble.s	grap.nohi2
	move.l	#(vew_wid)*8*2,d0
	move.l	#$61,d6

grap.nohi2	
	btst	#6,d5			;super hires ?
	beq.s	grap.noshi2

	move.l	#(vew_wid-4)*8*4,d0
	move.l	#2,d1
	move.l	#$81,d6

	cmp.w	#80*2,pic_wid(a2)	;overscan ?
	ble.s	grap.noshi2
	move.l	#(vew_wid)*8*4,d0
	move.l	#$61,d6

grap.noshi2	

	clr.w	d5
	cmp.w	d0,d4			;breeder dan scherm ?
	ble.s	grap.c
	move.w	d4,d5
	move.w	d0,d4
	sub.w	d0,d5			;modulo
	lsr.w	#3,d5			;/8
grap.c
	lsr.w	d1,d0
	lsr.w	d1,d4

	move.w	d0,d2
	sub.w	d4,d2
	lsr.w	#1,d2			;/2

	add.w	d6,d2
	move.b	d2,3(a1)		;x start
	move.w	d2,d3			;d3 bewaren !

	add.w	d4,d2			;d4 bewaren !
	move.b	d2,7(a1)		;x end
	
	move.w	pic_vew(a2),d6
	btst	#15,d6			;hires ?
	beq.s	grap.nohi5	
	add.l	d4,d4			;*2
grap.nohi5
	btst	#6,d6			;super hires ?
	beq.s	grap.noshi5	
	add.l	d4,d4			;*4
grap.noshi5

	move.l	d7,-(sp)
	move.w	pic_vew(a2),d6
	move.l	#17,d0
	move.l	#1,d1
	move.l	#3,d7

	btst	#15,d6			;hires ?
	beq.s	grap.nohi3	
	move.l	#9,d0
	move.l	#2,d1
	move.l	#2,d7
grap.nohi3
	btst	#6,d6			;super hires ?
	beq.s	grap.noshi3	
	move.l	#9,d0
	move.l	#2,d1
	move.l	#1,d7
grap.noshi3
	sub.w	d0,d3
	lsr.w	#1,d3
	move.w	d3,10(a1)		;ddfstrt
	
	move.w	d4,d2			;pic breedte in pixels
	lsr.w	#4,d2			;/16
	sub.w	d1,d2			;-1

	lsl.w	d7,d2			;*8
	add.w	d2,d3
	move.w	d3,14(a1)		;ddfstop
	move.l	(sp)+,d7
	
	lea	pic_raw(a2),a0

	moveq.l	#0,d2
	move.w	pic_dpt(a2),d2
	sub.l	#1,d2
	muls	pic_wid(a2),d2
	add.w	d2,d5

	move.w	pic_vew(a2),d2		;viewmode add
	btst	#2,d2
	beq.s	grap.nolace4

	moveq.l	#0,d2
	move.w	pic_dpt(a2),d2
	muls	pic_wid(a2),d2
	add.w	d2,d5			;interlace gedoe
grap.nolace4

	lea	gracprbpl,a4		;iffpln neerzetten
	lea	gracprpln,a0		;iffpln neerzetten
	moveq.l	#0,d2
	move.w	pic_dpt(a2),d2		;plnnummer 1 halen
	move.l	#8,d6			;copper step !

	tst.l	curpic2			;2de picture ?
	bne.s	grap.pic2
grap.nopic2
	move.w	d5,34(a1)		;modulo oneven zetten
	bra	grap.nodpl
grap.pic2
	move.l	curpic2,a3		;oneven plane
	move.l	currot2,a5		;oneven plane
	clr.l	curpic2			;mischien niet goed
	clr.l	curpal2			;mischien niet goed
	clr.l	currot2			;mischien niet goed

	cmp.l	curpic1,a3		;picture hetzelfde ?
	beq	grap.nopic2
	
	cmp.l	#0,currot1		;routine ?	
	beq.s	grap.norot
	cmp.l	currot1,a5		;routine hetzelfde ?
	beq	grap.nopic2
grap.norot

	cmp.b	#3,d2			;> 8 kleuren ?
	bgt	grap.nopic2
	move.w	pic_dpt(a3),d3		;plnnummer 2 halen
	cmp.b	d2,d3			;gelijke plnummers ?
	bne	grap.nopic2
	move.w	pic_vew(a2),d1
	cmp.w	pic_vew(a3),d1		;view gelijk ?
	bne	grap.nopic2

	move.w	pic_vew(a2),d1		;groter dan view test
	btst	#6,d1			;super hires ?
	beq.s	grap.nohi2a
	move.l	#vew_wid*4,d1
	bra.s	grap.nohi2b
grap.nohi2a
	btst	#15,d1			;hires ?
	beq.s	grap.noshi2a
	move.l	#vew_wid*2,d1
	bra.s	grap.nohi2b
grap.noshi2a
	move.l	#vew_wid,d1
grap.nohi2b
	cmp.w	pic_wid(a2),d1		;breder dan view ?
	bgt.s	grap.small
	cmp.w	pic_wid(a3),d1		;breder dan view ?
	bgt.s	grap.small

	move.w	pic_vew(a2),d1
	btst	#2,d1
	beq.s	grap.nolace8a
	move.l	hogscr,d1
	add.l	d1,d1
	bra.s	grap.nolace8b
grap.nolace8a
	move.l	hogscr,d1
grap.nolace8b
	cmp.w	pic_hgt(a2),d1		;hoger dan view ?
	bgt.s	grap.small
	cmp.w	pic_hgt(a3),d1		;hoger dan view ?
	bgt.s	grap.small
	bra.s	grap.big

grap.small
	move.w	pic_hgt(a2),d1		;wid+hgt<vew
	cmp.w	pic_hgt(a3),d1		;hoogte gelijk ?
	bne	grap.nopic2
	move.w	pic_wid(a2),d1
	cmp.w	pic_wid(a3),d1		;breedte gelijk ?
	bne	grap.nopic2

grap.big
	move.l	a3,curpic2
	move.l	a3,curpal2
	move.l	a5,currot2

	tst.b	dplctr			;double playfield al gezet ?
	beq.s	grap.nocop

	move.w	30(a1),34(a1)		;modulo copieren

	move.w	2(a4),d1		;bplcon0
	btst	#10,d1			;al double playfield ?
	beq.s	grap.ta

	move.w	2(a0),10(a0)		;plane 0>1 copieren
	move.w	6(a0),14(a0)

	move.w	18(a0),26(a0)		;plane 2>3 copieren
	move.w	22(a0),30(a0)

	move.w	34(a0),42(a0)		;plane 4>5 copieren
	move.w	38(a0),46(a0)

	bra.s	grap.tb
grap.ta
	move.w	18(a0),42(a0)		;plane 2>5 copieren
	move.w	22(a0),46(a0)

	move.w	10(a0),26(a0)		;plane 1>3 copieren
	move.w	14(a0),30(a0)

	move.w	2(a0),10(a0)		;plane 0>1 copieren
	move.w	6(a0),14(a0)

grap.tb
	move.l	#palette,a3		;palette copieren

	move.w	#8-1,d1
grap.pal
	move.w	(a3)+,14(a3)
	dbra	d1,grap.pal

grap.nocop
	add.w	d3,d2
	lsl.w	#8,d2
	lsl.w	#4,d2
	or.w	#$400,d2
	move.w	d2,2(a4)		;bplcon0

	movem.l	d0-d7/a0-a6,-(sp)

	move.l	curpic,a2		;animpic ?
	move.l	curfrm,d7
	cmp.l	#0,a2
	bne.s	grap.noanipic

	move.l	curpic2,a2		;normal pic ?
	move.l	curfrm2,d7
	cmp.l	#0,a2
	beq.s	grap.nodplpic

grap.noanipic
	add.l	d6,a0
	add.w	d6,d6
	bsr.s	grappln			;a2,d6,d7,d0
grap.nodplpic
	movem.l	(sp)+,d0-d7/a0-a6
	add.w	d6,d6
	bra.s	grap.nodpla


grap.nodpl				;geen double playfield
	lsl.w	#8,d2
	lsl.w	#4,d2
	move.w	d2,2(a4)		;bplcon0

grap.nodpla
	move.w	d5,30(a1)		;modulo even

	moveq.l	#0,d3
	add.w	pic_vew(a2),d3		;viewmode add
	moveq.l	#0,d2
	move.w	2(a4),d2
	or.l	d3,d2
	or.l	#$300,d2		;genlock info
	move.w	d2,2(a4)
	
	bsr.s	grappln			;a2,d6,d7,d0

grap.end
	
	movem.l	(sp)+,d0-d7/a0-a6
	rts
		

	;sets on of the 2 possible pictures to the copper
	;handles interlace

	;d7=framenummer
	;d6=copperliststap
	;d0=raw planes positie
	;a2=current picture
grappln					;planes invullen 
	movem.l	d0-d7/a0-a6,-(sp)

	lea	pic_raw(a2),a1
	move.l	a1,d0			;raw planes
	
	moveq.l	#0,d2			;x*y
	move.w	pic_wid(a2),d2
	lsr.l	#1,d2			;/2
	moveq.l	#0,d3
	move.w	pic_hgt(a2),d3
	muls	d3,d2
	
	move.l	d2,d4
	add.l	d2,d2

	move.w	pic_dpt(a2),d3
	muls	d3,d4			;hele picture size
	muls	d7,d4			;frame*size d7 !

	add.l	d4,d4

	add.l	d4,d0

	move.l	#vew_wid,d5		;max x view
	move.l	hogscr,d4		;max y view
	move.w	pic_vew(a2),d1		;viewmode add
	btst	#2,d1
	beq.s	grappln.nolace
	add.l	d4,d4			;max y view
grappln.nolace
	btst	#15,d1			;hires ?
	beq.s	grappln.nohi
	move.l	#vew_wid*2,d5		;max x view
grappln.nohi
	btst	#6,d1			;super hires ?
	beq.s	grappln.noshi
	move.l	#vew_wid*4,d5		;max x view
grappln.noshi

	moveq.l	#0,d3			;scherm centreren
	move.w	pic_wid(a2),d3		;pic breedte in bytes
	cmp.w	d5,d3			;breder dan scherm ?
	ble.s	grappln.qa
	sub.w	d5,d3			;-scherm breedte
	lsr.w	#2,d3			;/4

	add.l	d3,d3

	add.l	d3,d0
grappln.qa
	move.w	pic_hgt(a2),d3		;pic hoogte in bytes
	cmp.w	d4,d3			;hoger dan scherm ?
	ble.s	grappln.qb
	sub.w	d4,d3			;-scherm breedte
	lsr.w	#1,d3			;/2
	moveq.l	#0,d5
	move.w	pic_wid(a2),d5		;pic breedte in bytes
	muls	pic_dpt(a2),d5
	muls	d5,d3
	add.l	d3,d0
grappln.qb
	moveq.l	#0,d2
	move.w	pic_wid(a2),d2

	move.w	pic_vew(a2),d5		;interlace flipping ?
	btst	#2,d5
	beq.s	grappln.nolac7b

	move.w	$04(a6),d5		;even/oneven ?
	btst	#15,d5
	beq.s	grappln.nolac7b
	
	moveq.l	#0,d3
	move.w	pic_wid(a2),d3
	muls	pic_dpt(a2),d3
	add.l	d3,d0
grappln.nolac7b

	move.w	pic_dpt(a2),d1		;plnnummer 1 halen
	tst.w	d1			;0 planes ?
	beq.s	grappln.end
	sub.w	#1,d1
grappln.a
	move.w	d0,3*2(a0)
	swap	d0
	move.w	d0,1*2(a0)
	swap	d0
	add.l	d6,a0			;d6=copper step !
	add.l	d2,d0
	dbra	d1,grappln.a
grappln.end
	movem.l	(sp)+,d0-d7/a0-a6
	rts

	;sets palettes to copper
	
grac
	movem.l	d0-d7/a0-a6,-(sp)

	lea	curpal1,a3		;palette 1
	move.l	#palette,a1
	bsr.s	gracfrm

	lea	curpal2,a3		;palette 2 (dpl)
	move.l	#8*2+palette,a1
	bsr.s	gracfrm
	
	bsr.s	palctr			;palette-buffer to copper
grac.end
	movem.l	(sp)+,d0-d7/a0-a6
	rts
		
	;moves palette from picture to palette-buffer

gracfrm
	movem.l	d0-d7/a0-a6,-(sp)
	tst.l	(a3)			;palette aanwezig ?
	beq.s	gracfrm.end

	move.l	(a3),a2			;current palette
	
	cmp.l	#'PALE',(a2)		;palette ?
	bne.s	gracfrm.pict
	lea	6(a2),a0		;palette
	move.w	4(a2),d0		;aantal kleuren
	bra.s	gracfrm.col
gracfrm.pict
	cmp.l	#'ANIM',(a2)		;animatie ?
	bne.s	gracfrm.noanim

	moveq.l	#0,d1
	move.w	pic_ani(a2),d1
	bclr	#7,d1			;behandelbit weghalen

	moveq.l	#0,d3
	move.w	pic_wid(a2),d3
	lsr.w	#1,d3			;/2
	muls	pic_hgt(a2),d3
	muls	pic_dpt(a2),d3

	add.l	d3,d3

	add.l	#pic_raw,d3
	move.l	d3,d5

	btst	#0,d1
	bne.s	gracfrm.buf2
	moveq.l	#0,d5
gracfrm.buf2
	add.l	d5,a2
gracfrm.noanim
	lea	pic_pal(a2),a0		;palette
	move.w	pic_palnum(a2),d0

	cmp.w	#32-1,d0		;niet meer dan 32 kleuren
	ble	gracfrm.sub
	move.w	#32-1,d0
gracfrm.sub

	tst.w	d0			;0 planes ?
	beq.s	gracfrm.end
gracfrm.col
gracfrm.fa
	move.w	(a0)+,(a1)+
	dbra	d0,gracfrm.fa
gracfrm.end
	movem.l	(sp)+,d0-d7/a0-a6
	rts
	
	;handles colorcycling in the palette-buffer
	;and copies palette-buffer to copper

palctr
	movem.l	d0-d7/a0-a6,-(sp)

	move.l	curpic1,a2		;current raw
	cmp.l	#0,a2
	beq.s	palctr.qb
	lea	cycdel1,a3		;cycle delays
	move.l	#palette,a4
	bsr	palcyc
palctr.qb
	move.l	curpic2,a2		;current raw
	cmp.l	#0,a2
	beq.s	palctr.c
	lea	cycdel2,a3		;cycle delays
	move.l	#8*2+palette,a4
	bsr	palcyc

palctr.c
	lea	gracprcol,a1
	move.l	#palette,a0

	move.w	00(a0),00*4+2(a1)
	move.w	02(a0),01*4+2(a1)
	move.w	04(a0),02*4+2(a1)
	move.w	06(a0),03*4+2(a1)
	move.w	08(a0),04*4+2(a1)
	move.w	10(a0),05*4+2(a1)
	move.w	12(a0),06*4+2(a1)
	move.w	14(a0),07*4+2(a1)
	move.w	16(a0),08*4+2(a1)
	move.w	18(a0),09*4+2(a1)

	move.w	20(a0),10*4+2(a1)
	move.w	22(a0),11*4+2(a1)
	move.w	24(a0),12*4+2(a1)
	move.w	26(a0),13*4+2(a1)
	move.w	28(a0),14*4+2(a1)
	move.w	30(a0),15*4+2(a1)
	move.w	32(a0),16*4+2(a1)
	move.w	34(a0),17*4+2(a1)
	move.w	36(a0),18*4+2(a1)
	move.w	38(a0),19*4+2(a1)

	move.w	40(a0),20*4+2(a1)
	move.w	42(a0),21*4+2(a1)
	move.w	44(a0),22*4+2(a1)
	move.w	46(a0),23*4+2(a1)
	move.w	48(a0),24*4+2(a1)
	move.w	50(a0),25*4+2(a1)
	move.w	52(a0),26*4+2(a1)
	move.w	54(a0),27*4+2(a1)
	move.w	56(a0),28*4+2(a1)
	move.w	58(a0),29*4+2(a1)

	move.w	60(a0),30*4+2(a1)
	move.w	62(a0),31*4+2(a1)

	movem.l	(sp)+,d0-d7/a0-a6
	rts

	;colorcyclinghandling of a palette

palcyc
	movem.l	d0-d7/a0-a6,-(sp)
	move.w	#4-1,d7			;4 cycles
palcyc.d
	tst.w	(a3)+			;delay klaar ?
	bne.s	palcyc.c
	
	moveq.l	#0,d1
	move.b	pic_cycstr(a2),d1	;start color
	lsl.b	#1,d1		;*2

	moveq.l	#0,d2
	move.b	pic_cycend(a2),d2	;end color
	lsl.b	#1,d2		;*2

	moveq.l	#0,d3
	move.b	pic_cycadd(a2),d3	;richting

	move.l	a4,a0			;palette pointer
	move.l	a0,a1
	add.l	d1,a0			;startcolor
	add.l	d2,a1			;endcolor
	
	cmp.b	#1,d3			;omhoog
	beq.s	palcyc.up
	cmp.b	#3,d3			;omlaag
	beq.s	palcyc.down
	bra.s	palcyc.i

palcyc.up				;kleuren copieren
	move.w	(a1),d4			;laatst color bewaren
palcyc.f				;kleuren copieren
	cmp.l	a0,a1
	beq.s	palcyc.fa
	move.w	-(a1),2(a1)
	bra	palcyc.f
palcyc.fa
	move.w	d4,(a1)
	bra.s	palcyc.g	
	
palcyc.down
	move.w	(a0),d4			;laatst color bewaren
palcyc.h				;kleuren copieren
	cmp.l	a0,a1
	beq.s	palcyc.ha
	move.w	2(a0),(a0)+
	bra	palcyc.h
palcyc.ha
	move.w	d4,(a1)

palcyc.g
	move.b	pic_cycspd(a2),-1(a3)	;delay zetten
	bra.s	palcyc.i
palcyc.c
	sub.w	#1,-2(a3)		;cycle delay aftellen
palcyc.i
	add.l	#4,a2			;next cycle info
	dbra	d7,palcyc.d

palcyc.qb
	movem.l	(sp)+,d0-d7/a0-a6
	rts


;	SECTION	variabelen,DATA_c

	cnop	0,2
curtsk		dc.l	0
tskpri		dc.l	0
duplok		dc.l	0
inttel		dc.l	0
intdel		dc.l	0

form		dc.l	0
ifffil		dc.l	0
intvbold	dc.l	0
inttbeold	dc.l	0
patpos		dc.l	0
gfxlib		dc.l	0
doslib		dc.l	0
wbview  	dc.l	0
mt_data		dc.l	0
memvid		dc.l	0
oldcprlist	dc.l	0
hogscr		dc.l	vew_hgt

inspos		dc.l	-1
anispd1		dc.w	1	;nooit op 0 !
anispd2		dc.w	1

		cnop	0,2
varclr.s			;start wissen
oldrot		dc.l	0
curpic		dc.l	0
curfrm		dc.l	0
cycdel1		ds.w	4
cycdel2		ds.w	4

rotinf1		dc.w	0
rotinf2		dc.w	0

effspd		dc.w	0
efflop		dc.b	0
anilop1		dc.b	0
anilop2		dc.b	0
anipal1		dc.b	0
anipal2		dc.b	0
rotdpl		dc.b	1
dplctr		dc.b	0
		cnop	0,2

insdat		ds.l	4
inspri		dc.l	0
instel		dc.w	0

cureff		dc.l	0
efftel		dc.w	0

curpal1		dc.l	0
curpal2		dc.l	0
currot1		dc.l	0
currot2		dc.l	0
curpic1		dc.l	0
curpic2		dc.l	0
anitel1		dc.w	0
anitel2		dc.w	0
curfrm1		dc.l	0
curfrm2		dc.l	0
oldfrm1		dc.l	0
oldfrm2		dc.l	0

varclr.e
		dc.l	0			;wisruimte
	
varclr.ql	equ	varclr.e-varclr.s	;wislengte
	
;ownblit	dc.b	0
ntscmode	dc.b	0
end		dc.b	0

pronam	dc.b	'VideoTracker',0
	cnop	0,2
dosnam	dc.b	'dos.library',0
	cnop	0,4
gfxnam	dc.b	'graphics.library',0
	cnop	0,4
	
	cnop	0,4
gra.s
gracprscr
	dc.w	$8e,$3381,$90,$81c1,$92,$003c,$94,$00d0
gracprbpl
	dc.w	$100,$0000,$102,$0000,$104,$0020
	dc.w	$108,$0000,$10a,$0000
gracprpln
	dc.w	$e0,$0000,$e2,$0000
	dc.w	$e4,$0000,$e6,$0000
	dc.w	$e8,$0000,$ea,$0000
	dc.w	$ec,$0000,$ee,$0000
	dc.w	$f0,$0000,$f2,$0000
	dc.w	$f4,$0000,$f6,$0000
gracprcol
	dc.w	$180,0,$182,0,$184,0,$186,0,$188,0,$18a,0,$18c,0,$18e,0
	dc.w	$190,0,$192,0,$194,0,$196,0,$198,0,$19a,0,$19c,0,$19e,0
	dc.w	$1a0,0,$1a2,0,$1a4,0,$1a6,0,$1a8,0,$1aa,0,$1ac,0,$1ae,0
	dc.w	$1b0,0,$1b2,0,$1b4,0,$1b6,0,$1b8,0,$1ba,0,$1bc,0,$1be,0
cprjmp
	dc.w	$080,0,$082,0
gra.e
gra.ql	equ	gra.e-gra.s		;block lengte


cpr
	dc.w	$0001,$fffe
	dc.w	$09c,$8001		;tbeint
cprspr
	dc.w	$120,$0000,$122,$0000
	dc.w	$124,$0000,$126,$0000
	dc.w	$128,$0000,$12a,$0000
	dc.w	$12c,$0000,$12e,$0000
	dc.w	$130,$0000,$132,$0000
	dc.w	$134,$0000,$136,$0000
	dc.w	$138,$0000,$13a,$0000
	dc.w	$13c,$0000,$13e,$0000

cprbuf
	dc.w	$8e,$3381,$90,$81c1,$92,$003c,$94,$00d0
	dc.w	$100,$9000,$102,$0000,$104,$0020
	dc.w	$108,$0000,$10a,$0000
	dc.w	$e0,$0000,$e2,$0000
	dc.w	$e4,$0000,$e6,$0000
	dc.w	$e8,$0000,$ea,$0000
	dc.w	$ec,$0000,$ee,$0000
	dc.w	$f0,$0000,$f2,$0000
	dc.w	$f4,$0000,$f6,$0000
	dc.w	$180,0,$182,0,$184,0,$186,0,$188,0,$18a,0,$18c,0,$18e,0
	dc.w	$190,0,$192,0,$194,0,$196,0,$198,0,$19a,0,$19c,0,$19e,0
	dc.w	$1a0,0,$1a2,0,$1a4,0,$1a6,0,$1a8,0,$1aa,0,$1ac,0,$1ae,0
	dc.w	$1b0,0,$1b2,0,$1b4,0,$1b6,0,$1b8,0,$1ba,0,$1bc,0,$1be,0
	dc.w	$080,0,$082,0
cprbuf.e

	dc.w	$088,$0000		;copjmp2
	dc.w	$080,0,$082,0		;moet achter cprbck blijven !
cprbck
sprdat
	dc.w	$ffff,$fffe


prf_pat	equ	7			;pref sample size
prf_patnum	equ	128		;aantal songpos's
prf_len	equ	((prf_pat*prf_patnum)+1)

prf_pos	equ	0			;eff position (teller)

prf_effs	equ	1		;start effect (*prf_patnum)
prf_effe	equ	2		;end effect   (*prf_patnum)
prf_pri		equ	3		;priority     (*prf_patnum)
prf_spd		equ	4		;eff speed    (*prf_patnum)
prf_ani		equ	5		;ani speed    (*prf_patnum)
prf_roth	equ	6		;routine info (*prf_patnum)
prf_rotl	equ	7		;routine info (*prf_patnum)

eff_num	equ	256			;aantal effects

pic_wid		equ	4		;wide in bytes
pic_hgt		equ	6		;hoogte
pic_dpt		equ	8		;number planes
pic_ani		equ	10		;aantal effes (anim)
pic_vew		equ	12		;viewmode
pic_cycstr	equ	14		;cycle start (*4)
pic_cycend	equ	15		;cycle end (*4)
pic_cycspd	equ	16		;cycle speed (*4)
pic_cycadd	equ	17		;cycle add (*4)
pic_palnum	equ	30		;aantal kleuren
pic_pal		equ	32		;palette start
pic_palsiz	equ	256*2		;vaste palette size
pic_raw		equ	pic_pal+pic_palsiz	;palette start

fil_namlen	equ	24		;naamlengte
fil_len	equ	(fil_namlen+4+4)	;effect info length
fil_num	equ	2+eff_num		;aantal files
fil_fil	equ	0			;file naam 
fil_dir	equ	24			;pointer naar directory
fil_pnt	equ	28			;pointer naar meminfo

palette	ds.w	64	;palette

var_len		equ	$300		;lengte vartabel

var__GfxBase	equ	$000		;graphics lib
var_pic1	equ	$004		;current picture
var_anispd1	equ	$008		;animspeed
var_anitel1	equ	$00c		;animspeed
var_cprbck	equ	$010		;copperback
var_bck		equ	$014		;background
var_pic2	equ	$018		;current picture
var_ntsc	equ	$01c		;ntsc/pal frequence
var_lnd		equ	$020		;landscape
var_txt1	equ	$040		;text
var_txt16	equ	15*4+var_txt1
var_vec1	equ	$080		;vectors
var_vec16	equ	15*4+var_vec1
var_fon1	equ	$0c0		;fonts
var_fon16	equ	15*4+var_fon1
var_cols1	equ	$100		;colorsets
var_cols16	equ	15*4+var_cols1
var_obj1	equ	$180		;objects
var_obj16	equ	15*4+var_obj1

	cnop	0,2
var	ds.b	$300	;variabelen voor routines

	
;	SECTION	10,CODE_C
		endc

; this is the routine-source
;**********************************************************************

		ifnd	rout
pic_wid		equ	4		;wide in bytes
pic_hgt		equ	6		;hoogte
pic_dpt		equ	8		;number planes
pic_ani		equ	10		;aantal effes (anim)
pic_vew		equ	12		;viewmode
pic_cycstr	equ	14		;cycle start (*4)
pic_cycend	equ	15		;cycle end (*4)
pic_cycspd	equ	16		;cycle speed (*4)
pic_cycadd	equ	17		;cycle add (*4)
pic_palnum	equ	30		;aantal kleuren
pic_pal		equ	32		;palette start
pic_palsiz	equ	256*2		;vaste palette size
pic_raw		equ	pic_pal+pic_palsiz	;palette start

var_len		equ	$300		;lengte vartabel

var__GfxBase	equ	$000		;graphics lib
var_pic1	equ	$004		;current picture
var_anispd1	equ	$008		;animspeed
var_anitel1	equ	$00c		;animspeed
var_cprbck	equ	$010		;copperback
var_bck		equ	$014		;background
var_pic2	equ	$018		;current picture
var_ntsc	equ	$01c		;ntsc/pal frequence
var_lnd		equ	$020		;landscape
var_txt1	equ	$040		;text
var_txt16	equ	15*4+var_txt1
var_vec1	equ	$080		;vectors
var_vec16	equ	15*4+var_vec1
var_fon1	equ	$0c0		;fonts
var_fon16	equ	15*4+var_fon1
var_cols1	equ	$100		;colorsets
var_cols16	equ	15*4+var_cols1
var_obj1	equ	$180		;objects
var_obj16	equ	15*4+var_obj1

vew_wid	equ	44
vew_hgt	equ	290
win_hgt	equ	117
win_str	equ	$20
		endc


;calc		;on=calculate tunnel-data,off=play tunnel

		ifd	calc
rotpic_wid	equ	48
rotpic_hgt	equ	288
rotpic_dpt	equ	6
		endc
		
		ifnd	calc
rotpic_wid	equ	48
rotpic_hgt	equ	288
rotpic_dpt	equ	1

rotcop_hgt	equ	113
rotcop_dpt	equ	5
		endc
		
;	Input:
;	a0=variabelen tabel
;	d0=routinfo

;	Output:
;	a0=picture
;	d1=copperlist

	SECTION	3,CODE_C

rot
	dc.l	'ROUT'
	movem.l	d2-d7/a1-a6,-(sp)

	lea	($dff000).l,a6		;hardware
	lea	rot,a5			;prog base

	move.l	#32768,d2
	bsr	getd7

rot.ea	
;	move.l	#4,d2			;hoogte
;	bsr	getd7
;	muls	#1380,d7
;	move.l	d7,variabele1-rot(a5)

;	move.l	#1,d2			;breedte
;	bsr	getd7
;	muls	#6,d7
;	move.l	d7,variabele7-rot(a5)

rot.end
	move.l	var_cprbck(a0),d1
	sub.l	#8,d1

	move.l	a5,a1
	add.l	#rotcop1-rot,a1		;copperjump adres zetten
;	move.l	rotcopbuf-rot(a5),d2	;double buffer
;	add.l	d2,a1

	move.w	d1,6(a1)
	swap	d1
	move.w	d1,2(a1)

;	move.l	a1,a2
;	add.l	#rotcprbck1ntsc,a2
;	move.l	a1,a3
;	add.l	#rotcprend1ntsc,a3
;	move.l	a1,a4
;	add.l	#rotcprbck1,a4

;	cmp.b	#50,var_ntsc(a0)	;ntsc/pal frequence
;	bne	rot.ntsc

;	move.l	#$9029fffe,(a2)		;reset ntsc split
;	move.l	#$fa29fffe,(a3)		;reset ntsc end
;	add.l	#rotcprbck1,a1
;	move.l	#$c825fffe,d0
;	bra	rot.split
;rot.ntsc
;	move.l	#$c825fffe,(a4)		;reset pal split
;	move.l	#$00880000,(a3)		;set ntsc end
;	add.l	#rotcprbck1ntsc,a1
;	move.l	#$9029fffe,d0

;rot.split
;	move.l	#$00880000,(a1)		;set break
;	move.l	var_cprbck(a0),a2
;	cmp.b	#$ff,(a2)		;menu uit ?
;	bne	rot.a
;	move.l	d0,(a1)
rot.a

	bsr	rotint			;eventueel init

	ifnd	calc
	bsr	rotvew
	endc

	lea	rotpic,a0		;picture

	ifnd	calc
	add.l	rotbuf-rot(a5),a0
	eor.l	#rotpic.e-rotpic,rotbuf-rot(a5)
	endc

	clr.l	d1
	
	ifnd	calc
	move.l	a5,d1
	add.l	#rotcop1-rot,d1		;copperlist
	endc
	
	movem.l	(sp)+,d2-d7/a1-a6
	rts

getd7
	move.w	d0,d1
	divs	d2,d1
	and.l	#$ffff,d1
	move.l	d1,d7
	muls	d2,d1
	sub.w	d1,d0
	move.l	d0,d6
	add.l	#1,d7
	rts

rotint					;convert picture bits to bytes
	movem.l	d0-d7/a0-a6,-(sp)

	ifnd	calc
	move.l	a5,a1
	add.l	#rotcoptus.s-rot,a1
	tst.b	(a1)			;init copper ?
	bne	rotint.pic

	move.l	a5,a2
	add.l	#rotcoppic+pic_raw-rot,a2
	move.l	a5,a4
	add.l	#rotcoppic+pic_pal-rot,a4

	move.l	rotcopstr-rot(a5),d1
	
;	lea	rotpic+pic_raw+2,a3	;screen picture
;	move.l	rotbuf-rot(a5),d5
;	add.l	a3,d5
	
	move.w	#rotcop_hgt-1,d0
rotint.g
;	move.w	#4-1,d4
rotint.ga
	move.b	d1,(a1)			;y-raster

;	move.w	d5,10(a1)
;	swap	d5
;	move.w	d5,6(a1)
;	swap	d5
	
	move.w	#rotpic_wid/8-1,d7
rotint.h
	move.w	#8-1,d6
rotint.ha
	clr.w	d2
	btst	d6,(a2)
	beq	rotint.hab
	bset	#0,d2
rotint.hab
	btst	d6,6(a2)
	beq	rotint.hac
	bset	#1,d2
rotint.hac
	btst	d6,2*6(a2)
	beq	rotint.had
	bset	#2,d2
rotint.had
	btst	d6,3*6(a2)
	beq	rotint.hae
	bset	#3,d2
rotint.hae
	btst	d6,4*6(a2)
	beq	rotint.haf
	bset	#4,d2
rotint.haf
	clr.l	d3
	move.w	d2,d3
	lsl.l	#1,d3			;words
	move.w	(a4,d3),d2
	move.w	d2,6(a1)
;	move.w	d2,14(a1)				
	add.l	#4,a1
	dbra	d6,rotint.ha		;next bit

	add.l	#1,a2			;next byte
	dbra	d7,rotint.h

	add.l	#4*6,a2			;next row
	
	add.l	#1,d1
;	add.l	#4+8,a1
	add.l	#4,a1
;	dbra	d4,rotint.ga

;	add.l	#4*rotpic_wid*rotpic_dpt,d5
	dbra	d0,rotint.g

	endc
	
rotint.pic
	move.l	var_bck(a0),a1		;background picture
	cmp.l	#0,a1			;empty ?
	beq	rotint.nopic

	cmp.l	rotbck-rot(a5),a1	;already on screen ?
	beq	rotint.nopic

	clr.l	d0
	move.w	pic_wid(a1),d0		;get width
	lsl.l	#3,d0			;*8 for pixelnumber
	cmp.w	#256,d0			;bigger than buffer ?
	bgt	rotint.nopic

	clr.l	d1
	move.w	pic_hgt(a1),d1		;heigth
	cmp.w	#512,d1			;bigger than buffer ?
	bgt	rotint.nopic
	muls	d1,d0			;* heigth

	cmp.l	#rotcol_l,d0		;bigger than buffer ?
	bgt	rotint.nopic

	move.l	a1,rotbck-rot(a5)

	lea	pic_pal(a1),a2

	ifd	calc
	lea	rotpic+pic_pal,a3
	move.l	(a2),(a3)
	move.l	4(a2),4(a3)
	move.l	8(a2),8(a3)
	move.l	12(a2),12(a3)
	move.l	16(a2),16(a3)
	move.l	20(a2),20(a3)
	move.l	24(a2),24(a3)
	move.l	28(a2),28(a3)

	move.l	32(a2),32(a3)
	move.l	36(a2),36(a3)
	move.l	40(a2),40(a3)
	move.l	44(a2),44(a3)
	move.l	48(a2),48(a3)
	move.l	52(a2),52(a3)
	move.l	56(a2),56(a3)
	move.l	60(a2),60(a3)
	endc
	
	ifnd	calc
	lea	rotpic2+pic_pal,a3
;	move.l	(a2),(a3)
;	move.l	4(a2),4(a3)
;	move.l	8(a2),8(a3)
;	move.l	12(a2),12(a3)
	endc
	
	move.l	a5,a4
	add.l	#rotcol-rot,a4		;start colorbuffer
	
	clr.l	d0
	move.w	pic_wid(a1),d0		;get width
	lea	pic_raw(a1),a2		;start raw planes

	clr.l	d1			;y start position
rotint.f
	clr.l	d6			;x start position
rotint.d

	move.l	#8-1,d7			;read bits of 1 byte
rotint.c

	clr.l	d3			;colorvalue
	move.l	a2,a3
	clr.l	d5			;colorinfo
rotint.c1
	btst	d7,(a2)			;get colorbits
	beq	rotint.c0	
	bset	d5,d3
rotint.c0	
	add.l	d0,a2
	add.l	#1,d5
	cmp.w	pic_dpt(a1),d5
	bne	rotint.c1
	move.l	a3,a2

	move.l	d1,d5			;y pos
	lsl.l	#8,d5			;*256 (width)

	move.l	d6,d4			;x byte pos	
	lsl.l	#3,d4			;make pixels
	add.l	#7,d4			;x bit pos
	sub.l	d7,d4

	move.l	a4,a3
	add.l	d4,a3
	add.l	d5,a3
	move.b	d3,(a3)
		
	dbra	d7,rotint.c

	add.l	#1,a2			;next byte

	add.l	#1,d6
	cmp.l	d0,d6
	bne	rotint.d

	clr.l	d4
	move.w	pic_dpt(a1),d4
	sub.w	#1,d4
	muls	d0,d4
	add.l	d4,a2

	add.l	#1,d1
	cmp.w	pic_hgt(a1),d1		;y-end reached ?
	bne	rotint.f
	
	bra	rotint.end
rotint.nopic
	ifd	calc
	bsr	rotcal
	endc
	
rotint.end	
	movem.l	(sp)+,d0-d7/a0-a6
	rts

	ifd	calc
rotcal					;calculate tunnel
	movem.l	d0-d7/a0-a6,-(sp)

	move.l	#32767-7000,d3		;size
rotcal.f
	move.l	a5,a3
	add.l	#rotcol-rot,a3
rotcal.d
	move.w	#((32767-7000)/256)/1-1,d6	;sinus pixel heigth
rotcal.c
	btst	#6,($bfe001).l
	beq	rotcal.end

	lea	rotsin,a0
	move.l	a3,a1
	move.w	#256-1,d0		;tunnel picture width
rotcal.a
	move.b	(a1)+,d1
	
	move.w	#4-1,d7			;sinus pixel width
rotcal.e

	clr.l	d2
	move.w	(a0)+,d2
	ext.l	d2
	divs	d3,d2
	ext.l	d2			;x

	cmp.l	#rotpic_wid*4,d2	;out of border ?
	bge	rotcal.not
	cmp.l	#-rotpic_wid*4,d2
	blt	rotcal.not
	
	move.l	a5,a4
	add.l	#rotoff-rot,a4
	move.l	d2,d5
	add.l	#rotpic_wid*4,d5
	lsl.l	#2,d5			;longwords
	add.l	d5,a4
		
	add.l	#rotpic_wid*4,d2

	lea	rotpic+pic_raw,a2
	move.l	d2,d4
	lsr.l	#3,d4
	add.l	d4,a2
	lsl.l	#3,d4
	eor.b	#7,d2
	sub.l	d4,d2
					
	clr.l	d4
	move.w	(((rotsin_l/4)/2)*2)-2(a0),d4
	ext.l	d4
	divs	d3,d4
	ext.l	d4			;y

	cmp.l	#rotpic_hgt/2,d4	;out of border ?
	bge	rotcal.not
	cmp.l	#-rotpic_hgt/2,d4
	blt	rotcal.not
	
	move.l	d4,d5
	add.l	#rotpic_hgt/2,d5
	muls	#rotpic_wid*8*4,d5	;longwords
	add.l	d5,a4

	move.l	a1,a6			;current picture position
	sub.l	a5,a6			;-rot
	sub.l	#rotcol-rot,a6		;-rotcol
	move.l	a6,(a4)			;offset table
		
	add.l	#rotpic_hgt/2,d4
	muls	#rotpic_wid*rotpic_dpt,d4
	add.l	d4,a2
	
	moveq.l	#0,d4
rotcal.b2	
	btst	d4,d1
	beq	rotcal.b1
	bset	d2,(a2)
	bra	rotcal.b1a
rotcal.b1
	bclr	d2,(a2)
rotcal.b1a
	add.l	#rotpic_wid,a2
	add.b	#1,d4
	cmp.b	#rotpic_dpt,d4
	bne	rotcal.b2

rotcal.not
	dbra	d7,rotcal.e		;next sinus-position
	
	dbra	d0,rotcal.a		;next x-pixel

	sub.l	#1*1,d3
	cmp.l	#0,d3
	ble	rotcal.end
	dbra	d6,rotcal.c		;next sinus-size

	add.l	#256,a3			;next tunnelpicture y-row
	move.l	a3,d0
	sub.l	#rotcol,d0
	cmp.l	#256*256,d0
	bne	rotcal.d
	bra	rotcal.f
rotcal.end
	movem.l	(sp)+,d0-d7/a0-a6
	rts
	endc
	

rotvew					;show tunnel on screen
	movem.l	d0-d7/a0-a6,-(sp)
	move.l	a5,a0
	add.l	#rotoff-rot,a0		;tunnel data
	lea	rotpic+pic_raw,a1	;screen picture
	add.l	rotbuf-rot(a5),a1

	move.l	a5,a6
	add.l	#rotcol.e-rot,a6	;tunnel picture

rotvew.e1
	move.l	rotpos-rot(a5),d4
	add.l	#256,d4
	cmp.l	#(512+256)*256,d4
	bne	rotvew.e
	clr.l	rotpos-rot(a5)
	bra	rotvew.e1
rotvew.e	
	move.l	d4,rotpos-rot(a5)
	sub.l	d4,a6

	move.w	#(rotpic_hgt/4)-1,d6
rotvew.d
	rept	((rotpic_wid)/4)

	moveq.l	#0,d4			;plane 0
	
	movem.l	(a0)+,a2-a5

	add.l	a6,a2
	move.b	(a2),d5
	dc.w	$6704
	bset	#29,d4

	add.l	a6,a3
	move.b	(a3),d5
	dc.w	$6704
	bset	#25,d4

	add.l	a6,a4
	move.b	(a4),d5
	dc.w	$6704
	bset	#21,d4

	add.l	a6,a5
	move.b	(a5),d5
	dc.w	$6704
	bset	#17,d4

	movem.l	(a0)+,a2-a5

	add.l	a6,a2
	move.b	(a2),d5
	dc.w	$6704
	bset	#13,d4

	add.l	a6,a3
	move.b	(a3),d5
	dc.w	$6704
	bset	#09,d4

	add.l	a6,a4
	move.b	(a4),d5
	dc.w	$6704
	bset	#05,d4

	add.l	a6,a5
	move.b	(a5),d5
	dc.w	$6704
	bset	#01,d4

	move.l	d4,(a1)+

	endr

	add.l	#(3*(rotpic_wid*rotpic_dpt))+(rotpic_wid*(rotpic_dpt-1)),a1
	dbra	d6,rotvew.d
	
			
rotvew.end
	movem.l	(sp)+,d0-d7/a0-a6
	rts


rotbuf		dc.l	0
rotcopbuf	dc.l	0
rotbck		dc.l	0
rotpos		dc.l	0
rotcopstr	dc.l	$73

	ifd	calc
rotsin
       dc.w       0,201,402,603,804,1005,1206,1407,1608,1809,2009,2210
       dc.w       2410,2611,2811,3012,3212,3412,3612,3811,4011,4210,4410,4609
       dc.w       4808,5007,5205,5404,5602,5800,5998,6195,6393,6590,6786,6983
       dc.w       7179,7375,7571,7767,7962,8157,351,8545,8739,8933,9126,9319
       dc.w       9512,9704,9896,10087,10278,10469,10659,10849,11039,11228,11417,11605
       dc.w       11793,11980,12167,12353,12539,12725,12910,13094,13279,13462,13645,13828
       dc.w       14010,14191,14372,14553,14732,14912,15090,15269,15446,15623,15800,15976
       dc.w       16151,16325,16499,16673,16846,17018,17189,17360,17530,17700,17869,18037
       dc.w       18204,18371,18537,18703,18868,19032,19195,19357,19519,19680,19841,20000
       dc.w       20159,20317,20475,20631,20787,20942,21096,21250,21403,21554,21705,21856
       dc.w       22005,22154,22301,22448,22594,22739,22884,23027,23170,23311,23452,23592
       dc.w       23731,23870,24007,24143,24279,24413,24547,24680,24811,24942,25072,25201
       dc.w       25329,25456,25582,25708,25832,25955,26077,26198,26319,26438,26556,26674
       dc.w       26790,26905,27019,27133,27245,27356,27466,27575,27683,27790,27896,28001
       dc.w       28105,28208,28310,28411,28510,28609,28706,28803,28898,28992,29085,29177
       dc.w       29268,29358,29447,29535,29621,29706,29791,29874,29956,30037,30117,30195
       dc.w       30273,30349,30424,30498,30571,30643,30714,30783,30852,30919,30985,31050
       dc.w       31113,31176,31237,31297,31356,31414,31470,31526,31580,31633,31685,31736
       dc.w       31785,31833,31880,31926,31971,32014,32057,32098,32137,32176,32213,32250
       dc.w       32285,32318,32351,32382,32412,32441,32469,32495,32521,32545,32567,32589
       dc.w       32609,32628,32646,32663,32678,32692,32705,32717,32728,32737,32745,32752
       dc.w       32757,32761,32765,32766,32767,32766,32765,32761,32757,32752,32745,32737
       dc.w       32728,32717,32705,32692,32678,32663,32646,32628,32609,32589,32567,32545
       dc.w       32521,32495,32469,32441,32412,32382,32351,32318,32285,32250,32213,32176
       dc.w       32137,32098,32057,32014,31971,31926,31880,31833,31785,31736,31685,31633
       dc.w       31580,31526,31470,31414,31356,31297,31237,31176,31113,31050,30985,30919

       dc.w       30852,30783,30714,30643,30571,30498,30424,30349,30273,30195,30117,30037
       dc.w       29956,29874,29791,29706,29621,29535,29447,29358,29268,29177,29085,28992
       dc.w       28898,28803,28706,28609,28510,28411,28310,28208,28105,28001,27896,27790
       dc.w       27683,27575,27466,27356,27245,27133,27019,26905,26790,26674,26556,26438
       dc.w       26319,26198,26077,25955,25832,25708,25582,25456,25329,25201,25072,24942
       dc.w       24811,24680,24547,24413,24279,24143,24007,23870,23731,23592,23452,23311
       dc.w       23170,23027,22884,22739,22594,22448,22301,22154,22005,21856,21705,21554
       dc.w       21403,21250,21096,20942,20787,20631,20475,20317,20159,20000,19841,19680
       dc.w       19519,19357,19195,19032,18868,18703,18537,18371,18204,18037,17869,17700
       dc.w       17530,17360,17189,17018,16846,16673,16499,16325,16151,15976,15800,15623
       dc.w       15446,15269,15090,14912,14732,14553,14372,14191,14010,13828,13645,13462
       dc.w       13279,13094,12910,12725,12539,12353,12167,11980,11793,11605,11417,11228
       dc.w       11039,10849,10659,10469,10278,10087,9896,9704,9512,9319,9126,8933
       dc.w       8739,8545,8351,8157,7962,7767,7571,7375,7179,6983,6786,6590
       dc.w       6393,6195,5998,5800,5602,5404,5205,5007,4808,4609,4410,4211
       dc.w       4011,3811,3612,3412,3212,3012,2811,2611,2410,2210,2009,1809
       dc.w       1608,1407,1206,1005,804,603,402,201,0,-201,-402,-603
       dc.w       -804,-1005,-1206,-1406,-1607,-1808,-2009,-2209,-2410,-2610,-2811,-3011
       dc.w       -3211,-3411,-3611,-3811,-4011,-4210,-4409,-4608,-4807,-5006,-5205,-5403
       dc.w       -5601,-5799,-5997,-6195,-6392,-6589,-6786,-6982,-7179,-7375,-7571,-7766
       dc.w       -7961,-8156,-8351,-8545,-8739,-8932,-9126,-9319,-9511,-9703,-9895,-10087
       dc.w       -10278,-10469,-10659,-10849,-11038,-11227,-11416,-11604,-11792,-11980,-12166,-12353
       dc.w       -12539,-12724,-12909,-13094,-13278,-13462,-13645,-13827,-14009,-14191,-14372,-14552
       dc.w       -14732,-14911,-15090,-15268,-15446,-15623,-15799,-15975,-16150,-16325,-16499,-16672
       dc.w       -16845,-17017,-17189,-17360,-17530,-17699,-17868,-18036,-18204,-18371,-18537,-18702
       dc.w       -18867,-19031,-19194,-19357,-19519,-19680,-19840,-20000,-20159,-20317,-20474,-20631
       dc.w       -20787,-20942,-21096,-21249,-21402,-21554,-21705,-21855,-22004,-22153,-22301,-22448
       dc.w       -22594,-22739,-22883,-23027,-23169,-23311,-23452,-23592,-23731,-23869,-24006,-24143
       dc.w       -24278,-24413,-24546,-24679,-24811,-24942,-25072,-25201,-25329,-25456,-25582,-25707
       dc.w       -25831,-25954,-26077,-26198,-26318,-26437,-26556,-26673,-26789,-26905,-27019,-27132
       dc.w       -27244,-27355,-27466,-27575,-27683,-27790,-27896,-28001,-28105,-28208,-28309,-28410
       dc.w       -28510,-28608,-28706,-28802,-28897,-28992,-29085,-29177,-29268,-29358,-29446,-29534
       dc.w       -29621,-29706,-29790,-29873,-29955,-30036,-30116,-30195,-30272,-30349,-30424,-30498
       dc.w       -30571,-30643,-30713,-30783,-30851,-30918,-30984,-31049,-31113,-31175,-31236,-31297
       dc.w       -31356,-31413,-31470,-31525,-31580,-31633,-31684,-31735,-31785,-31833,-31880,-31926
       dc.w       -31970,-32014,-32056,-32097,-32137,-32176,-32213,-32249,-32284,-32318,-32350,-32382
       dc.w       -32412,-32441,-32468,-32495,-32520,-32544,-32567,-32588,-32609,-32628,-32646,-32662
       dc.w       -32678,-32692,-32705,-32717,-32727,-32736,-32744,-32751,-32757,-32761,-32764,-32766
       dc.w       -32767,-32766,-32764,-32761,-32757,-32751,-32744,-32736,-32727,-32717,-32705,-32692
       dc.w       -32678,-32662,-32646,-32628,-32609,-32588,-32567,-32544,-32520,-32495,-32468,-32441
       dc.w       -32412,-32382,-32350,-32318,-32284,-32249,-32213,-32176,-32137,-32097,-32056,-32014
       dc.w       -31970,-31926,-31880,-31833,-31785,-31735,-31684,-31633,-31580,-31525,-31470,-31413
       dc.w       -31356,-31297,-31236,-31175,-31113,-31049,-30984,-30918,-30851,-30783,-30713,-30643
       dc.w       -30571,-30498,-30424,-30349,-30272,-30195,-30116,-30036,-29955,-29873,-29790,-29706
       dc.w       -29621,-29534,-29446,-29358,-29268,-29177,-29085,-28992,-28897,-28802,-28706,-28608
       dc.w       -28510,-28410,-28309,-28208,-28105,-28001,-27896,-27790,-27683,-27575,-27466,-27355
       dc.w       -27244,-27132,-27019,-26905,-26789,-26673,-26556,-26437,-26318,-26198,-26077,-25954
       dc.w       -25831,-25707,-25582,-25456,-25329,-25201,-25072,-24942,-24811,-24679,-24546,-24413
       dc.w       -24278,-24143,-24006,-23869,-23731,-23592,-23452,-23311,-23169,-23027,-22883,-22739
       dc.w       -22594,-22448,-22301,-22153,-22004,-21855,-21705,-21554,-21402,-21249,-21096,-20942
       dc.w       -20787,-20631,-20474,-20317,-20159,-20000,-19840,-19680,-19519,-19357,-19194,-19031
       dc.w       -18867,-18702,-18537,-18371,-18204,-18036,-17868,-17699,-17530,-17360,-17189,-17017
       dc.w       -16845,-16672,-16499,-16325,-16150,-15975,-15799,-15623,-15446,-15268,-15090,-14911
       dc.w       -14732,-14552,-14372,-14191,-14009,-13827,-13645,-13462,-13278,-13094,-12909,-12724
       dc.w       -12539,-12353,-12166,-11980,-11792,-11604,-11416,-11227,-11038,-10849,-10659,-10469
       dc.w       -10278,-10087,-9895,-9703,-9511,-9319,-9126,-8932,-8739,-8545,-8351,-8156
       dc.w       -7961,-7766,-7571,-7375,-7179,-6982,-6786,-6589,-6392,-6195,-5997,-5799
       dc.w       -5601,-5403,-5205,-5006,-4807,-4608,-4409,-4210,-4011,-3811,-3611,-3411
       dc.w       -3211,-3011,-2811,-2610,-2410,-2209,-2009,-1808,-1607,-1406,-1206,-1005
       dc.w       -804,-603
rotsin.e
rotsin_l	equ	rotsin.e-rotsin

       dc.w       0,201,402,603,804,1005,1206,1407,1608,1809,2009,2210
       dc.w       2410,2611,2811,3012,3212,3412,3612,3811,4011,4210,4410,4609
       dc.w       4808,5007,5205,5404,5602,5800,5998,6195,6393,6590,6786,6983
       dc.w       7179,7375,7571,7767,7962,8157,351,8545,8739,8933,9126,9319
       dc.w       9512,9704,9896,10087,10278,10469,10659,10849,11039,11228,11417,11605
       dc.w       11793,11980,12167,12353,12539,12725,12910,13094,13279,13462,13645,13828
       dc.w       14010,14191,14372,14553,14732,14912,15090,15269,15446,15623,15800,15976
       dc.w       16151,16325,16499,16673,16846,17018,17189,17360,17530,17700,17869,18037
       dc.w       18204,18371,18537,18703,18868,19032,19195,19357,19519,19680,19841,20000
       dc.w       20159,20317,20475,20631,20787,20942,21096,21250,21403,21554,21705,21856
       dc.w       22005,22154,22301,22448,22594,22739,22884,23027,23170,23311,23452,23592
       dc.w       23731,23870,24007,24143,24279,24413,24547,24680,24811,24942,25072,25201
       dc.w       25329,25456,25582,25708,25832,25955,26077,26198,26319,26438,26556,26674
       dc.w       26790,26905,27019,27133,27245,27356,27466,27575,27683,27790,27896,28001
       dc.w       28105,28208,28310,28411,28510,28609,28706,28803,28898,28992,29085,29177
       dc.w       29268,29358,29447,29535,29621,29706,29791,29874,29956,30037,30117,30195
       dc.w       30273,30349,30424,30498,30571,30643,30714,30783,30852,30919,30985,31050
       dc.w       31113,31176,31237,31297,31356,31414,31470,31526,31580,31633,31685,31736
       dc.w       31785,31833,31880,31926,31971,32014,32057,32098,32137,32176,32213,32250
       dc.w       32285,32318,32351,32382,32412,32441,32469,32495,32521,32545,32567,32589
       dc.w       32609,32628,32646,32663,32678,32692,32705,32717,32728,32737,32745,32752
       dc.w       32757,32761,32765,32766,32767,32766,32765,32761,32757,32752,32745,32737
       dc.w       32728,32717,32705,32692,32678,32663,32646,32628,32609,32589,32567,32545
       dc.w       32521,32495,32469,32441,32412,32382,32351,32318,32285,32250,32213,32176
       dc.w       32137,32098,32057,32014,31971,31926,31880,31833,31785,31736,31685,31633
       dc.w       31580,31526,31470,31414,31356,31297,31237,31176,31113,31050,30985,30919


rotpic
		dc.l	'PICT'
		dc.w	rotpic_wid,rotpic_hgt,rotpic_dpt,1,0
		ds.b	4*4
		dc.w	32-1
		dc.w	$000,$00f,$0f0,$0ff,$f00,$f0f,$ff0,$fff
		dc.w	$000,$00f,$0f0,$0ff,$f00,$f0f,$ff0,$fff
		dc.w	$000,$00f,$0f0,$0ff,$f00,$f0f,$ff0,$fff
		dc.w	$000,$00f,$0f0,$0ff,$f00,$f0f,$ff0,$fff
		ds.w	256-32
		ds.b	rotpic_wid*rotpic_hgt*rotpic_dpt
		endc	

		ifnd	calc
rotpic
		dc.l	'PICT'
		dc.w	rotpic_wid,rotpic_hgt,rotpic_dpt,1,0
		ds.b	4*4
		dc.w	7
		dc.w	$000,$fff,$0f0,$0ff,$f00,$f0f,$ff0,$fff
		ds.w	256-8
		ds.b	rotpic_wid*rotpic_hgt*rotpic_dpt
rotpic.e
rotpic2
		dc.l	'PICT'
		dc.w	rotpic_wid,rotpic_hgt,rotpic_dpt,1,0
		ds.b	4*4
		dc.w	7
		dc.w	$000,$fff,$0f0,$0ff,$f00,$f0f,$ff0,$fff
		ds.w	256-8
		ds.b	rotpic_wid*rotpic_hgt*rotpic_dpt
		endc

rotoff
		ifd	calc
		ds.l	rotpic_wid*8*rotpic_hgt
		endc
		ifnd	calc
		incbin	'videotracker:bin/tun1.bin'
		cnop	0,2
		endc
rotoff.e
rotoff_l	equ	rotoff.e-rotoff

		ds.b	256*256
rotcol		ds.b	512*256
rotcol.e
		ds.b	256*256
		
rotcol_l	equ	rotcol.e-rotcol

rotcoppic
		incbin	'videotracker:bin/coppertunnel_l32.bin'

rotcop1
	dc.w	$80,0,$82,0

rotcoptus.s
	dc.w	$002f,$fffe
;	dc.w	$002b,$fffe
;	dc.w	$e0,0,$e2,0
	dc.w	$182,0,$182,0,$182,0,$182,0,$182,0,$182,0,$182,0,$182,0
	dc.w	$182,0,$182,0,$182,0,$182,0,$182,0,$182,0,$182,0,$182,0
	dc.w	$182,0,$182,0,$182,0,$182,0,$182,0,$182,0,$182,0,$182,0
	dc.w	$182,0,$182,0,$182,0,$182,0,$182,0,$182,0,$182,0,$182,0
	dc.w	$182,0,$182,0,$182,0,$182,0,$182,0,$182,0,$182,0,$182,0
	dc.w	$182,0,$182,0,$182,0,$182,0,$182,0,$182,0,$182,0,$182,0
rotcoptus.e
rotcoptus_l	equ	rotcoptus.e-rotcoptus.s

	rept	rotcop_hgt-1
	dc.w	$002f,$fffe
;	dc.w	$002b,$fffe
;	dc.w	$e0,0,$e2,0
	dc.w	$182,0,$182,0,$182,0,$182,0,$182,0,$182,0,$182,0,$182,0
	dc.w	$182,0,$182,0,$182,0,$182,0,$182,0,$182,0,$182,0,$182,0
	dc.w	$182,0,$182,0,$182,0,$182,0,$182,0,$182,0,$182,0,$182,0
	dc.w	$182,0,$182,0,$182,0,$182,0,$182,0,$182,0,$182,0,$182,0
	dc.w	$182,0,$182,0,$182,0,$182,0,$182,0,$182,0,$182,0,$182,0
	dc.w	$182,0,$182,0,$182,0,$182,0,$182,0,$182,0,$182,0,$182,0
	endr
	dc.w	$088,$000
rot.e

;**********************************************************************

	ifd	rout
rotsrc
	incbin	'videotracker:effect/tunnel1_l2.bck'
;	incbin	'videotracker:effect/world_l8.bck'
;	incbin	'videotracker:effect/copperpic_l8.bck'
;	incbin	'videotracker:effect/copperpic_l64.bck'
	cnop	0,2
	endc
	